%
% karcher_DP_1d_align.m
%
% default options
% option.parallel = 0; % turns offs MATLAB parallel processing (need
% parallel processing toolbox)
% option.closepool = 0; % determines wether to close matlabpool
% option.smooth = 0; % smooth data using standard box filter
% option.sparam = 25; % number of times to run filter
% option.showplot = 1; % turns on and off plotting

clear;
tic
lambda = 0;
%option.parallel = 0;
%option.closepool = 0;
option.toy = 1;
option.smooth = 1;
%option.sparam = 25;
option.showplot = 1;

% time warping on a set of functions
%if option.parallel == 1
%    if matlabpool('size') == 0
%        matlabpool open
%    end
%end

% Parameters

fprintf('\n lambda = %5.1f \n', lambda);

if option.toy == 1
   m = 101
   n = 29
   history = 10
   strpwidth = 20
else

%  m = 32001
   m = 20001
   n = 5 
   history = 12
   strpwidth = 150
end
t = linspace(0,1,m);
binsize = mean(diff(t));

%%Input curves
%loc = sprintf('Cell_Data/cells/DLEX1');

if option.toy == 0
 ispan = 25;
 fprintf('\nReading, resampling and possibly smoothing data ...\n');
 disp(' ')
 del(1) = 0;
 len = -100;

 for i = 1:n

   fprintf('Curve %d\n',i);

%  idx = sprintf('load %s/DLEX1theta%d.txt',loc,i);
%  idx = sprintf('load DLEX1theta%d.txt',i);
   idx = sprintf('load column%d.txt',i);
   eval(idx);

%  cmd = sprintf('C = DLEX1theta%d;',i);
   cmd = sprintf('C = column%d;',i);
   eval(cmd);

   p1= C';
   dt = max(p1(1,:))-min(p1(1,:));
   t1 = (p1(1,:)-min(p1(1,:)))/dt;
   b1 = p1(2,:);
   p1n = spline(t1,b1,t);
   f(:,i) = p1n(:) - p1n(1);
   f0(:,i) = f(:,i);

   if option.smooth == 1
      b1 = smooth(t1,p1(2,:),ispan);
      p1n = spline(t1,b1,t);
      f(:,i) = p1n(:) - p1n(1);
   end

   for j = 2:m
       del(j) = abs(f(j,i)-f(j-1,i));
   end
   lun = sum(del);
   lun
   if len < lun
      len = lun;
   end
 end

 len
 f1=f;
 f=f1/len;
else
 for i = 1:n

%  fprintf('Curve %d\n',i);

   idx = sprintf('load toy%d.txt',i);
   eval(idx);

   cmd = sprintf('C = toy%d;',i);
   eval(cmd);

%  p1= C';
%  dt = max(p1(1,:))-min(p1(1,:));
%  t1 = (p1(1,:)-min(p1(1,:)))/dt;
%  b1 = p1(2,:);
%  p1n = spline(t1,b1,t);
%  f(:,i) = p1n(:) - p1n(1);
   f(:,i) = C';
 end
 f0 = f;
 f1 = f;
end

[M, N] = size(f);

%if option.smooth == 1
%    for r = 1:option.sparam
%        for i = 1:N
%            f(2:(M-1),i) = (f(1:(M-2),i)+2*f(2:(M-1),i) + f(3:M,i))/4;
%        end
%    end
%end

if option.showplot == 1
 if option.toy == 0
    figure(1); clf;
    plot(t, f0, 'linewidth', 1);
    title('Resampled original curves', 'fontsize', 12);
    pause(0.1);
    figure(2); clf;
    plot(t, f1, 'linewidth', 1);
    title('Resampled (smoothed) original curves', 'fontsize', 12);
    pause(0.1);
    figure(3); clf;
    plot(t, f, 'linewidth', 1);
    title('Resampled scaled (smoothed) original curves', 'fontsize', 12);
    pause(0.1);
 else
    figure(1); clf;
    plot(t, f, 'linewidth', 1);
    title('Original curves', 'fontsize', 12);
    pause(0.1);
 end
end
if option.toy == 0
 fprintf('\n Reading, resampling (and smoothing) time = %f \n', toc);
 tic
end

%% Compute the q-function of the plot
%
%addpath(genpath('bspline_tools'))
%fy = zeros(M,N);
%for ii = 1:N
%    y = Bspline(f(:,ii),3);
%    ydiff = diff(y);
%    fy(:,ii) = ydiff(1:length(t))/binsize;
%    f(:,ii) = y(1:length(t));
%end
%q = fy./sqrt(abs(fy)+eps);
%q = sign(fy).*sqrt(abs(fy));
%
for ii = 1:N
%  q(:,ii) = gradient(f(:,ii), binsize)./sqrt(abs(gradient(f(:,ii), binsize))+eps);
   q(:,ii) = sign(gradient(f(:,ii), binsize)).*sqrt(abs(gradient(f(:,ii), binsize)));
end

%% Set initial mean using the original f space
fprintf('\nInitializing...\n');
mnq = mean(q,2);
dqq = sqrt(sum((q - mnq*ones(1,N)).^2,1));
[~, min_ind] = min(dqq);
fprintf('\nInitial mean is function %d\n', min_ind);
mq = q(:,min_ind);
mf = f(:,min_ind);

%history = 12
%strpwidth = 150
iopt = 1
%imeth = 1

gam = zeros(N,size(q,1));
mq_c = mq';
q1= [0*t;mq_c];
fprintf('\nFirst Karcher mean computation ...\n');
%parfor k = 1:N
for k = 1:N
    q_c = q(:,k,1)';
%   if(imeth)
       q2= [0*t;q_c];
[gam0,ifly,iflp,mnrgy]= DP_MEX_WNDSTRP(q1,q2,t,t,history,strpwidth,iopt);
    if(option.toy == 0)
      mnrgy
    end
%   else
%      [G,T] = DynamicProgrammingQ2(mq_c/norm(mq_c),t,q_c/norm(q_c),t,t,t,lambda);
%      gam0 = interp1(T,G,t);
%   end
    gam(k,:) = (gam0-gam0(1))/(gam0(end)-gam0(1));  % slight change on scale
    gam_dev(k,:) = gradient(gam(k,:), 1/(M-1));
    f_temp(:,k) = interp1(t, f(:,k), (t(end)-t(1)).*gam(k,:) + t(1))';
    f1_temp(:,k) = interp1(t, f1(:,k), (t(end)-t(1)).*gam(k,:) + t(1))';
%   q_temp(:,k) = gradient(f_temp(:,k), binsize)./sqrt(abs(gradient(f_temp(:,k), binsize))+eps);

    q_temp(:,k) = sign(gradient(f_temp(:,k), binsize)).*sqrt(abs(gradient(f_temp(:,k), binsize)));
    q_tomp(:,k) = q_temp(:,k)/norm(q_temp(:,k));
end
qq(:,:) = q_tomp;
%ds = sum(simps(t, (mq(:)*ones(1,N)-qq(:,:)).^2)) + ...
%        lambda*sum(simps(t, (1-sqrt(gam_dev')).^2));
ds = sum(simps(t, ((mq(:)/norm(mq))*ones(1,N)-qq(:,:)).^2)) + ...
        lambda*sum(simps(t, (1-sqrt(gam_dev')).^2));
dss = ds;
if option.toy == 0
   dss
end

%
gamI = SqrtMeanInverse(gam);
gamI_dev = gradient(gamI, 1/(M-1));
mf = interp1(t, mf, (t(end)-t(1)).*gamI + t(1))';
%mq = gradient(mf, binsize)./sqrt(abs(gradient(mf, binsize))+eps);
mq = sign(gradient(mf, binsize)).*sqrt(abs(gradient(mf, binsize)));
for k = 1:N
    f_tomp(:,k) = interp1(t, f_temp(:,k), (t(end)-t(1)).*gamI + t(1))';
    f_tump(:,k) = interp1(t, f1_temp(:,k), (t(end)-t(1)).*gamI + t(1))';
    gam(k,:) = interp1(t, gam(k,:), (t(end)-t(1)).*gamI + t(1));
end

if option.showplot == 1
  if option.toy == 0
    figure(4); clf;
    plot((0:M-1)/(M-1), gam, 'linewidth', 1);
    axis square;
    title('Initial warping functions/diffeomorphisms', 'fontsize', 12);
    pause(0.1);
    figure(5); clf;
    plot(t, f_tump, 'LineWidth',1);
    title(['Initial aligned (smoothed) curves, \lambda = ' num2str(lambda)], 'fontsize', 12);
    pause(0.1);
    figure(6); clf;
    plot(t, f_tomp, 'LineWidth',1);
    title(['Initial aligned scaled (smoothed) curves, \lambda = ' num2str(lambda)], 'fontsize', 12);
    pause(0.1);
    figure(7); clf;
    plot(t, mf, 'g','LineWidth',1);
    title(['Initial Karcher mean, \lambda = ' num2str(lambda)], 'fontsize', 12);
    pause(0.1);
  end
end

%% Compute Mean
%history = 12
%strpwidth = 150
fprintf('Computing Karcher mean of %d functions in SRVF space...\n',N);
disp(' ')
ds = inf;
MaxItr = 4;
qun = zeros(1,MaxItr);
for r = 1:MaxItr
    fprintf('updating step: r=%d\n', r);
    if r == MaxItr
        disp(' ')
        fprintf('maximal number of iterations has been reached. \n');
    end
    
    % Matching Step
    clear gam gam_dev;
    % use DP to find the optimal warping for each function w.r.t. the mean
    gam = zeros(N,size(q,1));
    gam_dev = zeros(N,size(q,1));
    mq_c = mq(:,r)';
    q1= [0*t;mq_c];
%   parfor k = 1:N
    for k = 1:N
       q_c = q(:,k,1)';
%      if(imeth)
          q2= [0*t;q_c];
[gam0,ifly,iflp,mnrgy]= DP_MEX_WNDSTRP(q1,q2,t,t,history,strpwidth,iopt);
        if(option.toy == 0)
           mnrgy
        end
%       else
%         [G,T] = DynamicProgrammingQ2(mq_c/norm(mq_c),t,q_c/norm(q_c),t,t,t,lambda);
%         gam0 = interp1(T,G,t);
%       end
        gam(k,:) = (gam0-gam0(1))/(gam0(end)-gam0(1));  % slight change on scale
        gam_dev(k,:) = gradient(gam(k,:), 1/(M-1));
        f_temp(:,k) = interp1(t, f(:,k,1), (t(end)-t(1)).*gam(k,:) + t(1))';
%       q_temp(:,k) = gradient(f_temp(:,k), binsize)./sqrt(abs(gradient(f_temp(:,k), binsize))+eps);

        q_temp(:,k) = sign(gradient(f_temp(:,k), binsize)).*sqrt(abs(gradient(f_temp(:,k), binsize)));
        q_tomp(:,k) = q_temp(:,k)/norm(q_temp(:,k));
    end
    qq(:,:) = q_tomp;
    q(:,:,r+1) = q_temp;
    f(:,:,r+1) = f_temp;
    
    ds(r+1) = sum(simps(t, ((mq(:,r)/norm(mq(:,r)))*ones(1,N)-qq(:,:)).^2)) + ...
        lambda*sum(simps(t, (1-sqrt(gam_dev')).^2));
    dss  = ds(r+1);
    
    % Minimization Step
    % compute the mean of the matched function
    mq(:,r+1) = mean(q(:,:,r+1),2);
    
    qun(r) = norm(mq(:,r+1)-mq(:,r))/norm(mq(:,r));
    diffr = qun(r);
   if option.toy == 0
      dss, diffr
    end
    if qun(r) < 1e-2 || r >= MaxItr
        break;
    end
end

% last step with centering of gam
%history = 12
%strpwidth = 150
r = r+1;
fprintf('finalizing step: r=%d\n', r);
mq_c = mq(:,r)';
q1= [0*t;mq_c];
%parfor k = 1:N
for k = 1:N
   q_c = q(:,k,1)';
%  if(imeth)
      q2= [0*t;q_c];
[gam0,ifly,iflp,mnrgy]= DP_MEX_WNDSTRP(q1,q2,t,t,history,strpwidth,iopt);
      if(option.toy == 0)
         mnrgy
      end
%  else
%    [G,T] = DynamicProgrammingQ2(mq_c/norm(mq_c),t,q_c/norm(q_c),t,t,t,lambda);
%    gam0 = interp1(T,G,t);
%  end
   gam(k,:) = (gam0-gam0(1))/(gam0(end)-gam0(1));  % slight change on scale
   gam_dev(k,:) = gradient(gam(k,:), 1/(M-1));
   f_temp(:,k) = interp1(t, f(:,k,1), (t(end)-t(1)).*gam(k,:) + t(1))';
   f1_temp(:,k) = interp1(t, f1(:,k,1), (t(end)-t(1)).*gam(k,:) + t(1))';
   f0_temp(:,k) = interp1(t, f0(:,k,1), (t(end)-t(1)).*gam(k,:) + t(1))';
%   q_temp(:,k) = gradient(f_temp(:,k), binsize)./sqrt(abs(gradient(f_temp(:,k), binsize))+eps);
   q_temp(:,k) = sign(gradient(f_temp(:,k), binsize)).*sqrt(abs(gradient(f_temp(:,k), binsize)));
   q_tomp(:,k) = q_temp(:,k)/norm(q_temp(:,k));
end
qq(:,:) = q_tomp;
ds(r+1) = sum(simps(t, ((mq(:,r)/norm(mq(:,r)))*ones(1,N)-qq(:,:)).^2)) + ...
        lambda*sum(simps(t, (1-sqrt(gam_dev')).^2));
dss = ds(r+1);
if option.toy == 0
   dss
end
%
gamI = SqrtMeanInverse(gam);
gamI_dev = gradient(gamI, 1/(M-1));
mq(:,r+1) = interp1(t, mq(:,r), (t(end)-t(1)).*gamI + t(1))'.*sqrt(gamI_dev');
for k = 1:N
    q(:,k,r+1) = interp1(t, q_temp(:,k), (t(end)-t(1)).*gamI + t(1))'.*sqrt(gamI_dev');
    f(:,k,r+1) = interp1(t, f_temp(:,k), (t(end)-t(1)).*gamI + t(1))';
    f_tump(:,k) = interp1(t, f1_temp(:,k), (t(end)-t(1)).*gamI + t(1))';
    f_timp(:,k) = interp1(t, f0_temp(:,k), (t(end)-t(1)).*gamI + t(1))';
%   q(:,k,r+1) = interp1(t, q(:,k,r), (t(end)-t(1)).*gamI + t(1))'.*sqrt(gamI_dev');
%   f(:,k,r+1) = interp1(t, f(:,k,r), (t(end)-t(1)).*gamI + t(1))';
    gam(k,:) = interp1(t, gam(k,:), (t(end)-t(1)).*gamI + t(1));
end

%% Aligned data & stats
fn = f(:,:,r+1);
qn = q(:,:,r+1);
q0 = q(:,:,1);
mean_f0 = mean(f0, 2);
std_f0 = std(f0, 0, 2);
mean_fn = mean(fn, 2);
std_fn = std(fn, 0, 2);
mqn = mq(:,r+1);
fmean = mean(f(1,:))+cumtrapz(t,mqn.*abs(mqn));
%mqs = mqn/norm(mqn);
%fms = mean(f(1,:))+cumtrapz(t,mqs.*abs(mqs));

fgam = zeros(M,N);
for ii = 1:N
    fgam(:,ii) = interp1(t, fmean, (t(end)-t(1)).*gam(ii,:) + t(1));
end
var_fgam = var(fgam,[],2);

stats.orig_var = trapz(t,std_f0.^2);
stats.amp_var = trapz(t,std_fn.^2);
stats.phase_var = trapz(t,var_fgam);

gam = gam.';
[~,fy] = gradient(gam,binsize,binsize);
psi = sqrt(fy+eps);

if option.showplot == 1
  if option.toy == 0
    figure(8); clf;
    plot((0:M-1)/(M-1), gam, 'linewidth', 1);
    axis square;
    title('Final warping functions/diffeomorphisms', 'fontsize', 12);
    
    figure(9); clf;
    plot(t, f_tump, 'LineWidth',1);
    title(['Final aligned (smoothed) curves, \lambda = ' num2str(lambda)], 'fontsize', 12);
    
    figure(10); clf;
    plot(t, fn, 'LineWidth',1);
    title(['Final aligned scaled (smoothed) curves, \lambda = ' num2str(lambda)], 'fontsize', 12);
    
    figure(11); clf;
    plot(t, f_timp, 'LineWidth',1);
    title(['Final aligned original curves, \lambda = ' num2str(lambda)], 'fontsize', 12);
    
    figure(12); clf;
    plot(t, fmean, 'g','LineWidth',1);
    title(['Final scaled Karcher mean, \lambda = ' num2str(lambda)], 'fontsize', 12);
    
%   figure(13); clf;
%   plot(t, mean_f0, 'b-', 'linewidth', 1); hold on;
%   plot(t, mean_f0+std_f0, 'r-', 'linewidth', 1);
%   plot(t, mean_f0-std_f0, 'g-', 'linewidth', 1);
%   title('Original curves: Regular mean \pm STD', 'fontsize', 12);
    
%   figure(14); clf;
%   plot(t, mean_fn, 'b-', 'linewidth', 1); hold on;
%   plot(t, mean_fn+std_fn, 'r-', 'linewidth', 1);
%   plot(t, mean_fn-std_fn, 'g-', 'linewidth', 1);
%   title(['Warped/aligned curves, \lambda = ' num2str(lambda) ': Regular mean \pm STD'], 'fontsize', 12);
    
%   figure(15); clf;
%   plot(t, fms, 'g','LineWidth',1);
%   title(['Final scaled Karcher mean, \lambda = ' num2str(lambda)], 'fontsize', 12);
  else
    figure(2); clf;
    plot((0:M-1)/(M-1), gam, 'linewidth', 1);
    axis square;
    title('Warping functions/diffeomorphisms', 'fontsize', 12);
    
    figure(3); clf;
    plot(t, fn, 'LineWidth',1);
    title(['Aligned curves, \lambda = ' num2str(lambda)], 'fontsize', 12);
    
    figure(4); clf;
    plot(t, fmean, 'g','LineWidth',1);
    title(['Karcher mean, \lambda = ' num2str(lambda)], 'fontsize', 12);
  end
end
%if option.parallel == 1 && option.closepool == 1
%    matlabpool close
%end

fprintf('\n Aligning time = %f \n', toc);
disp(' ')

